.libPaths("/acct/mhsaad/PROGS/R")
 library(kinship) 
 library(CompQuadForm)

 source("AFC.R")

 P1=vector("numeric")
 P2=vector("numeric")

for (j in 1:10)
{
 Genotypes=  read.table("AdditiveGenotyped.txt",h=TRUE)
 Genotypes[ , "IID"] = paste(Genotypes[ , "FID"]  , Genotypes[ , "IID"]  ,sep=".")
 Genotypes[Genotypes[,"FA"]!=0 , "FA"] = paste(Genotypes[Genotypes[,"FA"]!=0 , "FID"]  , Genotypes[Genotypes[,"FA"]!=0 , "FA"]  ,sep=".")
 Genotypes[Genotypes[,"FA"]!=0 , "MO"] = paste(Genotypes[Genotypes[,"FA"]!=0 , "FID"]  , Genotypes[Genotypes[,"FA"]!=0 , "MO"]  ,sep=".")
 Kinship = makekinship(Genotypes$FID , Genotypes$IID , Genotypes$FA, Genotypes$MO)
 KIN = as.matrix(Kinship)
 Phenotypes = read.table("Phenotype")
 Phenotype = matrix(Phenotypes[,j],nc=1,nr=nrow(Phenotypes))
 id = Genotypes$IID
 Genotypes = Genotypes[,7:ncol(Genotypes)]
 Na = nrow(Phenotypes[Phenotypes[,j]==1,])
 Nu = nrow(Phenotypes[Phenotypes[,j]==0,])
 N = Nu + Na
 Maf = matrix(NA , nr=ncol(Genotypes) , nc=2)
 Maf[,1] = colMeans(Genotypes[Phenotype==1,])/2;
 Maf[,2] = colMeans(Genotypes[Phenotype==0,])/2;
 P  = (Maf[,1]*Na + Maf[,2]*Nu)/N
 Set = which(P<0.05)
 Maf = Maf[c(Set),]
 COR = cor(Genotypes[,c(Set)])
 COR[is.na(COR)] = 0
 Genotypes=  as.matrix(Genotypes[,Set])

 WEIGHTS = matrix(1/(Maf[,2]+1),nc=1,nr=length(Set))
 CORREC = Xcorrec(MAF = Maf , Pheno = Phenotype, Kin = KIN , Correlation=COR, Weights = WEIGHTS)
 QLS = Wqls(Genotypes=Genotypes, MAF=Maf, Pheno = Phenotype, Kin= KIN, Correlation=COR, Weights= WEIGHTS)
 SKAT = famSKAT(MAF = Maf , Pheno = Phenotype, Kin = KIN , Correlation=COR, Weights = WEIGHTS)
 P1 = c(P1, CORREC[4])
 P2 = c(P2, QLS[4])
}
